// ==UserScript==
// @name CdC
// @description Petits outils pour la Couronne de Cuivre
// @include http://www.baldursgateworld.fr/*
// @grant GM_deleteValue
// @grant GM_setValue
// @grant GM_getValue
// ==/UserScript==

(function() {
	// Fonction gérant le changement de login.
	var request = function(username, keep) {
		try { trim(""); }
		catch (exception) {
			var xhr = new XMLHttpRequest();
			xhr.open("GET", "/lacouronne/clientscript/vbulletin_md5.js", false);
			xhr.send(null);
			if (xhr.readyState == 4)
				eval(xhr.responseText);
		}
		
		var data = new FormData();
		if (keep) data.append("cookieuser", "1");
		data.append("vb_login_username", username);
		var passwd = hex_md5(str_to_ent(trim(GM_getValue(username))));
		data.append("vb_login_md5password", passwd);
		var passwd = hex_md5(trim(GM_getValue(username)));
		data.append("vb_login_md5password_utf", passwd);
		data.append("securitytoken", "guest");
		data.append("vb_login_password", "");
		data.append("do", "login");
		data.append("s", "");
		
		var xhr = new XMLHttpRequest();
		xhr.open("POST", "/lacouronne/login.php?do=login", false);
		xhr.send(data);
		if (xhr.readyState == 4)
			return;
	};
	
	// Récupération du login de base.
	var charname = GM_getValue("relog");
	if (charname != undefined) {
		GM_deleteValue("relog");
		request(charname, true);
		window.location.reload(true);
	}
	
	/*var links = document.getElementsByClassName("newreply");
	for (var i=0; i<links.length; i++) {
		//TODO cibler seulement les messages concernés.
		var link = document.createElement("a");
		links[i].parentNode.insertBefore(link, links[i]);
		link.appendChild(document.createTextNode("Modifier le message"));
		var ref = "vB::QuickEdit::"+links[i].href.substr(links[i].href.lastIndexOf("=")+1);
		link.href = "javascript:vB_QuickEditor.edit('"+ref+"');"; //FIXME ne marche pas.
		link.className = "editpost";
		var sep = document.createElement("span");
		links[i].parentNode.insertBefore(sep, links[i]);
		sep.appendChild(document.createTextNode(" "));
		sep.className = "seperator";
	}*/
	
	// Vérifications de la page appelante…
	var zone = document.getElementsByClassName("posticons")[0];
	if (zone == undefined) return; // Pas une page de réponse.
	var rp = false; // Vérifions si on est en section RP…
	for (var i=0; i<document.links.length; i++)
		if (document.links[i].getAttribute("href") == "roleplay/")
			rp = true; // C'est bien du RP.
		else if (document.links[i].parentNode.className == "welcomelink")
			charname = document.links[i].firstChild.nodeValue;
	if (!rp) return; // Ce n'est pas du RP, inutile.
	
	// Création du champ de sélection du compte.
	var field = document.createElement("div");
	field.appendChild(document.createElement("select"));
	field.appendChild(document.createElement("img"));
	field.lastChild.src = "/lacouronne/avatars/"+charname+".gif";
	zone.insertBefore(field, zone.firstChild);
	field.firstChild.style.display = "block";
	field.firstChild.style.width = "100px";
	field.style.cssFloat = "right";
	field.firstChild.onchange = function() {
		this.nextSibling.src = "/lacouronne/avatars/"+this.value+".gif";
	};
	
	// Changements de compte en cliquant sur l'avatar.
	field.lastChild.onclick = function() {
		for (var i=1; i<field.firstChild.childNodes.length; i++)
			if (field.firstChild.childNodes[i-1].value == field.firstChild.value) {
				field.firstChild.value = field.firstChild.childNodes[i].value;
				field.firstChild.onchange();
				return;
			}
		field.firstChild.value = field.firstChild.firstChild.value;
		field.firstChild.onchange();
	};
	field.lastChild.oncontextmenu = function() {
		for (var i=1; i<field.firstChild.childNodes.length; i++)
			if (field.firstChild.childNodes[i].value == field.firstChild.value) {
				field.firstChild.value = field.firstChild.childNodes[i-1].value;
				field.firstChild.onchange();
				return false;
			}
		field.firstChild.value = field.firstChild.lastChild.value;
		field.firstChild.onchange();
		return false;
	};
	
	// Affichage des différents comptes à utiliser.
	var item = document.createElement("option");
	item.appendChild(document.createTextNode(charname));
	item.value = charname;
	field.firstChild.appendChild(item);
	var logins = GM_getValue("logins");
	if (logins == undefined) logins = new Array();
	else logins = logins.split(";");
	for (var i=0; i<logins.length; i++) {
		if (logins[i] == charname) continue;
		item = document.createElement("option");
		item.appendChild(document.createTextNode(logins[i]));
		item.value = logins[i];
		field.firstChild.appendChild(item);
	}
	
	// Création du bouton de configuration.
	field.appendChild(document.createElement("a"));
	field.lastChild.appendChild(document.createTextNode("⎘ Configurer"));
	field.lastChild.style.textAlign = "center";
	field.lastChild.style.display = "block";
	field.lastChild.style.width = "100px";
	field.lastChild.href = "javascript:";
	field.lastChild.onclick = function() {
		// Et fonctionnement de ce bouton.
		var screen = document.createElement("div");
		screen.style.backgroundColor = "#484848";
		document.body.appendChild(screen);
		screen.style.position = "fixed";
		screen.style.opacity = "0.5";
		screen.style.zIndex = "998";
		screen.style.bottom = "0";
		screen.style.right = "0";
		screen.style.left = "0";
		screen.style.top = "0";
		
		var list = document.createElement("ul");
		list.style.backgroundColor = "ActiveCaption";
		list.style.border = "2px ridge ActiveBorder";
		document.body.appendChild(list);
		list.style.position = "fixed";
		list.style.overflow = "auto";
		list.style.zIndex = "999";
		list.style.bottom = "25%";
		list.style.right = "25%";
		list.style.left = "25%";
		list.style.top = "25%";
		list.padding = "0.1em";
		
		item = document.createElement("li");
		item.appendChild(document.createTextNode("Liste des comptes :"));
		item.style.color = "CaptionText";
		item.style.fontSize = "1.2em";
		item.style.padding = "0.2em 0.5em";
		list.appendChild(item);
	
		for (var i=0; i<logins.length; i++) {
			item = document.createElement("li");
			item.style.padding = "0.2em";
			list.appendChild(item);
			
			item.appendChild(document.createElement("button"));
			item.lastChild.style.cssFloat = "right";
			item.lastChild.appendChild(document.createTextNode("✗"));
			item.lastChild.onclick = function() {
				list.removeChild(this.parentNode);
			};
			
			item.appendChild(document.createElement("input"));
			item.lastChild.style.width = "48%";
			item.lastChild.value = logins[i];
			item.lastChild.type = "text";
			item.appendChild(document.createElement("input"));
			item.lastChild.value = GM_getValue(logins[i]);
			item.lastChild.style.width = "45%";
			item.lastChild.type = "password";
		}
	
		item = document.createElement("li");
		item.style.padding = "0.2em 1em";
		item.style.color = "CaptionText";
		list.appendChild(item);
		
		item.appendChild(document.createElement("label"));
		item.firstChild.appendChild(document.createElement("input"));
		item.firstChild.firstChild.type = "checkbox";
		item.firstChild.appendChild(document.createTextNode(" Afficher les mots de passe"));
		item.firstChild.style.cssFloat = "right";
		item.firstChild.firstChild.onclick = function() {
			var type = this.checked?"text":"password";
			for (var i=1; i<list.childNodes.length-1; i++) {
				list.childNodes[i].lastChild.type = type;
			}
		};
		
		item.appendChild(document.createElement("button"));
		item.lastChild.appendChild(document.createTextNode("+ Nouveau"));
		item.lastChild.style.marginRight = "1em";
		item.lastChild.onclick = function() {
			item = document.createElement("li");
			list.insertBefore(item, this.parentNode);
			item.style.padding = "0.2em";
			
			item.appendChild(document.createElement("button"));
			item.lastChild.style.cssFloat = "right";
			item.lastChild.appendChild(document.createTextNode("✗"));
			item.lastChild.onclick = function() {
				list.removeChild(this.parentNode);
			};
			
			item.appendChild(document.createElement("input"));
			item.lastChild.style.width = "48%";
			item.lastChild.type = "text";
			item.lastChild.focus();
			item.appendChild(document.createElement("input"));
			item.lastChild.style.width = "45%";
			item.lastChild.type = "password";
		};
		
		item.appendChild(document.createElement("button"));
		item.lastChild.appendChild(document.createTextNode("✔ Valider"));
		item.lastChild.onclick = function() {
			var newlogs = "";
			for (var i=0; i<logins.length; i++)
				GM_deleteValue(logins[i]);
			logins = new Array();
			while (field.firstChild.childNodes.length > 1)
				field.firstChild.removeChild(field.firstChild.lastChild);
			for (var i=1; i<list.childNodes.length-1; i++) {
				var login = list.childNodes[i].childNodes[1].value;
				GM_setValue(login, list.childNodes[i].childNodes[2].value);
				newlogs += ";"+login;
				logins[i-1] = login;
				
				if (login == charname) continue;
				item = document.createElement("option");
				item.appendChild(document.createTextNode(login));
				item.value = login;
				field.firstChild.appendChild(item);
			}
			GM_setValue("logins", newlogs.substr(1));
			this.nextSibling.onclick();
		};
		
		item.appendChild(document.createElement("button"));
		item.lastChild.appendChild(document.createTextNode("♻ Annuler"));
		item.lastChild.onclick = function() {
			document.body.removeChild(screen);
			document.body.removeChild(list);
		};
	};
	
	var form = field;
	while (form.nodeName.toLowerCase() != "form")
		form = form.parentNode;
	var vbcheck = form.onsubmit;
	form.onsubmit = function() {
		if (vbcheck(form)) {
			var login = field.firstChild.value;
			if (login == charname) return true;
			GM_setValue("relog", charname);
			request(login, false);
			
			var xhr = new XMLHttpRequest();
			xhr.open("GET", window.location.href, false);
			xhr.send(null);
			if (xhr.readyState == 4) {
				var local = document.getElementsByName("securitytoken");
				var dist = (new DOMParser().parseFromString(xhr.responseText, "text/html")).getElementsByName("securitytoken");
				for (var i=0; i<local.length; i++)
					local[i].value = dist[i].value;
			}
			return true;
		}
		return false;
	};
})()
